    This files describes the implementation of the Atari ST version of Zoo 2.1.
Please read ZOO.MAN and then read this file.

GENERAL
-------
Zoo-ST accepts both slashes and backslashes as directory separators.

Zoo-ST preserves the atrributes of archived files.  So if you archive a
Read-Only file, it will be extracted as a Read-Only file.

Zoo-ST doesn't allow Zoo to be used as a filter. 

NEW OPTIONS
-----------
// - This option will recursively decend all the directories in the specified
     path when used in conjunction with the 'a' command.  NOTE: This is Atari
     specific and will change if/when R. Dhesi adds this option internally to
     Zoo.  This does not affect the ability of Zoo on other platforms to
     extract these archives.

NOVICE COMMANDS
---------------
-add
-freshen
-update
-move    - All default to the high compression mode.

-backup  - This is the same as the expert command 'ah//'.  It will recursively
           descend all directories in the path during an add.

-restore - This is the same as the expert command 'x//'.  It will extract files
           from the archive using full pathnames, if present.

WILDCARD HANDLING FROM THE DESKTOP
----------------------------------
The globbing routines used in the ST version of Zoo understand the following
elements:
    * or *.*    - Any sequence of zero or more characters.
    ?           - Any single character.
    [x...y]     - Any single character specified by the set x...y, where any
                  character other than minus sign or close bracket may appear
                  in the set.  A minus sign may be used to indicate a range of
                  characters.  ex. [0-5abc] is shorthand for [012345abc].  More
                  than one range may appear inside a character set.  ex.
                  [0-9a-zA-Z._] matches almost all of the legal characters for
                  a host name.
    [^ x...y]   - Any character NOT in the set, which is interpreted as 
                  described above.
    \*, \?, \[  - A *, ? or [ character.  ex. If you named a file '*' and you
                  want it added to a Zoo archive, you would use the following
                  command line:  'zoo ah foo.zoo \*'.  Try to avoid doing this.

UNIXMODE
--------
The released binary of Zoo does not fully support UNIXMODE.  The only
option of UNIXMODE not supported is mixed case.  This can be changed by
undefining FOLD in options.h and recompiling Zoo.  See the TOS section of
options.h for more details.  Undefining FOLD will NOT cause any incompatibility
problems with produced archives.  If you are unable to recompile Zoo and
want the UNIXMODE version, contact me at one of the email addresses below.

ZOOPAUSE
--------
If you launch Zoo-ST from the desktop, it will wait for a keypress when it is
done with it's current operation.  If Zoo-ST is launched from a recognized CLI
(currently Gulam, Master 5.0 & 5.4, Craft) or if the environment variable SHELL
is set, Zoo-ST will NOT wait for a keypress.  You may also set the environment
variable ZOOPAUSE to either "yes" or "no", depending on whether you want Zoo-ST
to wait or not.

ACKNOWLEDGMENTS
---------------

This port of Zoo was done using GCC V1.40 and the excellent libraries 
distributed with it.  Thanks to Jwahar Bammi and Eric Smith for all of the 
time and labor they put into this compiler package.

Thanks to Rahul Dhesi for developing Zoo and making it freely available to 
all users, on all platforms.

Thanks to Rich Salz for releasing his wildmat code to the public.  It saved us
alot of headaches developing our own from scratch.

Thanks to Dan Jitta for his port of Zoo 2.01 to the ST.  We used several of his
ideas in this port.

Please send all comments, suggestions, and bug reports to:

BillShroka
bjsjr@NCoast.ORG
ncoast!bjsjr@usenet.cwru.edu
uunet!usenet.cwru.edu!ncoast!bjsjr
GEnie: B.SHROKA
